
# Emacs

## Base

* `C-x C-s`: Save current file.
* `C-x C-f`: Find or open file.

## Markdown

[Module Reference](http://www.mplayerhq.hu/design7/news.html)

* `C-c C-s 1`: Insert level one heading with hash delimiter.
* `C-c C-c p`: Show preview in browser.
* `C-c C-x l`: Toggle url hiding
* `C-c C-x i`: Toggle inline images
* `C-c C-x m`: Toggle markdown visibility
* `S-Tab`: Toggle global visibility
* `TAB`: Toggle local header visibility


## Evil

[Reference card](https://michaelgoerz.net/refcards/vimqrc.pdf)

* `CTRL- {D, U, F, B}`: Scroll down/up by half or full page
* `zt zz zb`: Scroll current line to top, centre, bottom
* `0 $`: Move to beginning or end of line
* `{ }`: Move to beginning or end of paragraph
* `h l j k`: Character left, right, up, down
* `y p`: Yank (copy) or paste

## Magit

[Reference card](https://magit.vc/manual/magit-refcard.pdf)

* `CTRL-x g`: Status buffer
* `S`: Stage all changes
* `c`: Start a commit
  * `C-c C-c`: Finish a commit
* `P`: Start a push
  * `u`: Push to origin 

## Auctex

## Org Mode ##

https://orgmode.org/worg/org-tutorials/org4beginners.html

* `TAB/S-TAB`: Fold/Unfold
* `M-up/down`: move headline up/down
* `M-left/right`: promote or demote headline
* `M-RET`: add new headline

## Treemacs ##

https://github.com/Alexander-Miller/treemacs

* `C-c C-w s`: Switch workspace

## Lsp Mode ##

### Python ###

Install language LSP server:

```
brew install python-lsp-server
```

## Further Reading ##

* [Markdown Mode Book - Plaintext](https://github.com/jrblevin/markdown-mode-guide/blob/master/manuscript/guide.txt)
* [Emacs config for publishing](https://github.com/pprevos/emacs-writing-studio)
* [Emacs reference card](https://www.gnu.org/software/emacs/refcards/pdf/refcard.pdf)
* [Yasnippet repo](https://github.com/joaotavora/yasnippet)
* [Emacs Python](https://realpython.com/emacs-the-best-python-editor/)
* [Effective Emacs](https://sites.google.com/site/steveyegge2/effective-emacs)
* [Latex with emacs](https://michaelneuper.com/posts/efficient-latex-editing-with-emacs/)

